    processor 6502
    include vcs.h
    include macro.h
    include music.h

; Compile switches

NTSC                    = 0
PAL                     = 1 
COMPILE_VERSION         = NTSC

; Equates

FIREDELAY               = $0F
TEMPODELAY              = 4
PATTERNSIZE             = 6
SEQUENCESIZE            = 8
SEQUENCES               = 30
STATEOFFSET             = 43
SCOREOFFSET             = 59
STRIPE_SIZE             = 9
MINE_SIZE               = 11
SHIP_STRIPES            = 4
MINE_STRIPES            = 3
MINES                   = 2*MINE_STRIPES
XEDGE                   = 169
XEDGEMINES              = 156
SUBSINKSPEED            = $1F
SINKSPEED               = $07
EXPTIME                 = $0F
TORPEDOSTART            = $6C
TORPEDOS                = 4

SHIPCOL1                = $0F
SHIPCOL2                = $1C
SHIPCOL3                = $29

MINECOL1                = $35
MINECOL2                = $43
MINECOL3                = $4E

; Variables

    SEG.U vars
    ORG $80

spritePointer1      ds 2
spritePointer2      ds 2
spritePointer3      ds 2
spritePointer4      ds 2
spritePointer5      ds 2
spritePointer6      ds 2
colorPointer        ds 2
delayPointer        ds 2
bcdScore            ds 3
bcdHiScore          ds 3
torpedoyPos         ds 2
xPosMines           ds MINES
xPosMinesFloat      ds MINES
mineType            ds MINES
expTimer            ds MINES
xPos                ds SHIP_STRIPES
xDelay              ds SHIP_STRIPES
xPosabs             ds SHIP_STRIPES
xPosfloat           ds SHIP_STRIPES
xPosadd             ds SHIP_STRIPES
shipreflect         ds SHIP_STRIPES
shiptypeshape       ds SHIP_STRIPES
sinklevel           ds SHIP_STRIPES
frameCounter        ds 1
torpedoDelay        ds 1
chargeDelay         ds 1
torpedoHorPos       ds TORPEDOS
torpedoVerPos       ds TORPEDOS
torpedoAdd          ds TORPEDOS
rnd                 ds 1
tempoCount          ds 1
currentPattern      ds 1
currentNote         ds 1
currentSequence     ds 1
wateranim1          ds 1
wateranim2          ds 1
gameState           ds 1
fuel                ds 1
torpedos            ds 1
subs                ds 1
bRestockNow         ds 1
level               ds 1
tempVar1            ds 1
tempVar2            ds 1
tempVar3            ds 1
tempVar4            ds 1

FXTimer             ds 2
FXType              ds 2
FXFreq              ds 2
FXVol               ds 2

    SEG     Bank0
    ORG $F000

;#######################
;# MAIN SCREEN DISPLAY #
;#######################

; Start display kernel
Maindisplay
    STA WSYNC           
    STA VBLANK          ; Stop VBLANK

    IF COMPILE_VERSION = PAL
        LDA #$D6
    ELSE
        LDA #$86
    ENDIF

    STA COLUBK          ; Set background color

    LDA #SCOREOFFSET+8
    LDX #$01
    JSR PosElement
    DEX
    LDA #SCOREOFFSET
    JSR PosElement      ; Position score display

    STA WSYNC
    STA HMOVE
    STX GRP0
    STX COLUP0
    STX COLUP1
    LDA #%01011
    STA NUSIZ0
    STA NUSIZ1
    STA VDELP0
    STA VDELP1
    LDX #$09
    STX tempVar1        ; Prepare score display

    SLEEP 31

loop2
    LDY tempVar1
    LDA (spritePointer1),y
    LDX HORIZONCOLORS2,Y
    STX COLUBK
    STA.w GRP0
    LDA (spritePointer2),y
    STA GRP1
    LDA (spritePointer3),y
    STA GRP0
    LDA (spritePointer4),y
    STA tempVar2
    LAX (spritePointer5),y
    LDA (spritePointer6),y
    LDY tempVar2
    STY GRP1
    STX GRP0
    STA GRP1
    STA GRP0
    DEC tempVar1
    BPL loop2           ; Score display loop

    LDA #$00
    STA GRP0
    STA GRP1
    STA NUSIZ1
    STA NUSIZ0
    STA VDELP0
    STA VDELP1
    LDA #>SUB1
    STA spritePointer1+1
    STA spritePointer2+1
    STA spritePointer3+1    ; Cleanup after score display

    IF COMPILE_VERSION = PAL
        LDA #$C6
        STA COLUBK
        STA WSYNC
        LDA #$A6
        STA COLUBK
        LDA #$3A
        STA COLUP0
        STA COLUP1
    ELSE
        LDA #$76
        STA COLUBK
        STA WSYNC
        LDA #$66
        STA COLUBK
        LDA #$1A
        STA COLUP0
        STA COLUP1
    ENDIF





    STA REFP1       ; $A = %1010
    LDA #$78
    LDX #$00
    JSR PosElement
    LDA #$80
    INX
    JSR PosElement
    STA WSYNC       ;
    STA HMOVE       ; Begin repositioning scannline

    LDY #$0E

DoHorizon
    STA WSYNC   
    LDA HORIZONCOLORS,Y 
    STA COLUBK  
    SEC
    TYA
    SBC #$07
    ADC #$06
    BCC SkipDraw
    TAX
    LDA HORIZONSHAPE,X
    BNE Continue

SkipDraw    
    LDA #$00

Continue   
    STA GRP0
    STA GRP1
    DEY
    BPL DoHorizon

    INY
    STY COLUP0
    STY COLUP1  

; Ships
    INY
    STY NUSIZ0

    LDX #$03
    SEC
    JSR ShipStripe
    LDX #$02
    JSR ShipStripe
    LDX #$01
    JSR ShipStripe

; Mines
    STA NUSIZ0      ; A = 0
    STA COLUP0
    STA COLUP1
    STA REFP0
    STA REFP1
    LDA #MINE_STRIPES-1
    STA tempVar3
    LDA #>MINE
    STA spritePointer5+1
    STA spritePointer6+1

MineStripe
    LDA tempVar3
    ASL
    TAY
    LDA #$00
    STA COLUP0
    STA COLUP1

    LDA #3                  ; TJ torpedo magic
    DCP torpedoyPos
    ADC #2
    STA ENABL
    LDA #3
    DCP torpedoyPos+1
    ADC #2
    STA ENAM1               ; TJ magic end
    
    LDA frameCounter
    LSR
    LSR
    AND #$0F
    TAX

    LDA #<RESTOCK
    CMP mineType+1,Y
    BNE NoPod1
    STX COLUP1

NoPod1
    CMP mineType,Y
    BNE NoPod2
    STX COLUP0

NoPod2
    LDA xPosMines,Y
    LDX #$00
    JSR PosElement2
    LDX tempVar3
    LDA stripecolor2,X
    BIT wateranim1
    BEQ DontNow3
    STA COLUBK

DontNow3
    STA tempVar1
    LDA #3                  ; TJ torpedo magic
    DCP torpedoyPos
    ADC #2
    STA ENABL
    LDA #3
    DCP torpedoyPos+1
    ADC #2
    STA ENAM1               ; TJ magic end
    STA HMCLR
    LDA xPosMines+1,Y
    LDX #$01
    JSR PosElement2
    LDA tempVar1
    BIT wateranim2
    BEQ DontNow4
    STA COLUBK

DontNow4
    LDA mineType+1,Y
    STA spritePointer6
    LDA mineType,Y
    STA spritePointer5

    LDY #MINE_SIZE
StripeLine2
    LDA #3                  ; TJ torpedo magic
    DCP torpedoyPos
    ADC #2
    STA ENABL
    LDA #3
    DCP torpedoyPos+1
    ADC #2
    STA ENAM1               ; TJ magic end
    LAX (spritePointer6),Y
    LDA (spritePointer5),Y
    STA WSYNC
    STA GRP0
    STX GRP1
    LDA tempVar1
    STA COLUBK
    DEY
    BPL StripeLine2
    DEC tempVar3
    BMI DoTorpedoStripe
    JMP MineStripe

DoTorpedoStripe
    LDX #27

    IF COMPILE_VERSION = PAL
        LDY #$D2
        LDA wateranim1
        BNE DontNow5
        LDY #$D4    
    ELSE
        LDY #$82
        LDA wateranim1
        BNE DontNow5
        LDY #$84
    ENDIF

DontNow5

TorpedoZone    
    LDA #3                  ; TJ torpedo magic
    DCP torpedoyPos
    ADC #2
    STA ENABL
    LDA #3
    DCP torpedoyPos+1
    ADC #2
    STA ENAM1               ; TJ magic end

    STA WSYNC
    STY COLUBK

    IF COMPILE_VERSION = PAL
        LDY #$D2
    ELSE
        LDY #$82
    ENDIF

    DEX
    BNE TorpedoZone

    SEC
    JSR ShipStripe

    STA ENABL
    STA ENAM1

    SLEEP 40

    LDA #>FUEL1
    STA spritePointer1+1
    STA spritePointer2+1
    STA spritePointer3+1
    STA spritePointer4+1
    LDA #<FUEL1
    STA spritePointer1
    LDA #<FUEL2
    STA spritePointer2
    LDA #<TORP1
    STA spritePointer3
    LDA #<TORP2
    STA spritePointer4
    LDA #<SUBS1
    STA spritePointer5
    LDA #<SUBS2
    STA spritePointer6

    LDY #$04
    JSR Statekernel

    ; Fuel
    LAX fuel
    AND #$0F
    TAY 
    LDA digittab,Y
    STA spritePointer2
    TXA
    LSR
    LSR
    LSR
    LSR
    TAY
    LDA digittab,Y
    STA spritePointer1

    ; Torpedoes
    LAX torpedos
    AND #$0F
    TAY 
    LDA digittab,Y
    STA spritePointer4
    TXA
    LSR
    LSR
    LSR
    LSR
    TAY
    LDA digittab,Y
    STA spritePointer3

    ; Subs
    LAX subs
    AND #$0F
    TAY 
    LDA digittab,Y
    STA spritePointer6
    TXA
    LSR
    LSR
    LSR
    LSR
    TAY
    LDA digittab,Y
    STA spritePointer5
    
    LDY #$09
    JSR NextStateLine

    STA WSYNC
    
    LDA #$00
    STA COLUBK
    LDA #$02
    STA VBLANK

    JMP Overscan

;########################
;# CARTRIDGE MAIN ENTRY #
;########################

Start
    CLEAN_START
 
    LDX SHIP_STRIPES-1
InitLines
    JSR InitShip
    DEX
    BPL InitLines

    LDX #MINES-1
InitMines
    JSR Random
    CMP #XEDGEMINES
    BCS InitMines
    STA xPosMines,X
    LDA #<MINE
    STA mineType,X
    DEX
    BPL InitMines

    LDA #%00110000
    STA PF0
    
    LDA #5
    STA CTRLPF
    LDA #$00
    STA COLUP0
    STA COLUP1

    JSR SetTorpedos

    SET_POINTER colorPointer, CBLACK1
    SET_POINTER spritePointer1, SUB1
    SET_POINTER spritePointer2, SUB2
    SET_POINTER spritePointer3, BLANK
    SET_POINTER delayPointer, JNDELAY

    LDA #$20
    STA bcdHiScore+1
    LDA #$04
    STA bcdHiScore+2

; Main Program Loop

NEWSCREEN
    VERTICAL_SYNC

; Set VBLANK timer
    IF COMPILE_VERSION = PAL
        LDA #73
    ELSE
        LDA #43
    ENDIF
    STA TIM64T

; Do the math. The following calculates this formula:
; Y = 211 - int((X+2)/3)

    LDX #SHIP_STRIPES-1
CalculateDelay
    LDY #$01
    LDA xPos,X
    CLC
    ADC #02
    SEC

DivideBy3
    DEY
    SBC #$03
    BCS DivideBy3
    TYA
    ADC #<JNDELAY+46
    STA xDelay,X
    DEX 
    BPL CalculateDelay

; Eventually fire a torpedo!

    LDX #1
    LDY #2
    ASL SWCHB
    BCS Mode22
    INX
    INY

Mode22
    STX tempVar1
    STY tempVar2

    LDX #$01
    LDA shiptypeshape+1
    AND #%11110000
    CMP #%00100000
    BEQ DestroyerFound
    LDX #$FF

DestroyerFound    
    STX tempVar3

    BIT gameState
    BPL ProjectileLaunchDone2
    LDA torpedos
    BEQ TorpedoLaunchDone
    LDA torpedoDelay
    BEQ ContinueFire
    DEC torpedoDelay
    JMP TorpedoLaunchDone

ContinueFire
    LDA INPT4
    BMI TorpedoLaunchDone

    LDX tempVar1

FreeTorpedoSearch    
    LDA torpedoVerPos,X
    BPL TorpedoOccupied
    LDA #TORPEDOSTART
    STA torpedoVerPos,X
    LDA #$FF
    STA torpedoAdd,X
    LDA xPosabs
    SEC
    SBC #$06
    LDY shipreflect
    CPY #$00
    BNE LaunchReflected
    CLC
    ADC #$03

LaunchReflected
    STA torpedoHorPos,X
    LDA #FIREDELAY
    STA torpedoDelay
    SED
    LDA torpedos
    SEC
    SBC #$01
    STA torpedos
    CLD
    LDY #$00    
    JSR DoSFX
    LDX #$00

TorpedoOccupied
    DEX
    BPL FreeTorpedoSearch

TorpedoLaunchDone
    LDY tempVar3
    BMI ProjectileLaunchDone
    LDA chargeDelay
    BEQ ContinueFire2
    DEC chargeDelay

ProjectileLaunchDone2
    JMP ProjectileLaunchDone

ContinueFire2
    LDX tempVar2

FreeChargeSearch    
    LDA torpedoVerPos,X
    BPL TorpedoOccupied2
    LDA CollTab,Y
    STA torpedoVerPos,X

    LDA #$02
    BIT SWCHB
    BVS ModeFast
    LDA #$01

ModeFast
    STA torpedoAdd,X

    LDA xPos,Y
    ADC #12
    STA torpedoHorPos,X
    LDA #FIREDELAY*2
    STA chargeDelay
    LDY #10
    JSR DoSFX
    LDX #$03

TorpedoOccupied2
    INX
    CPX #$04
    BNE FreeChargeSearch    

; Flicker torpedos
ProjectileLaunchDone
    LDA frameCounter
    AND #$01
    ASL
    TAY

    LDA torpedoHorPos,Y
    LDX #$04
    JSR PosElement
    LDA torpedoVerPos,Y
    STA torpedoyPos
    LDA torpedoHorPos+1,Y
    LDX #$03
    JSR PosElement
    LDA torpedoVerPos+1,Y
    STA torpedoyPos+1

    STA WSYNC
    STA HMOVE

; Collision detection
    TYA
    EOR #%00000010
    TAY
    
    LDX #$00
    BIT CXM1P
    BMI CollisionM1
    INX
    BVS CollisionM1
    LDX #$00
    BIT CXP0FB
    BVS CollisionBL
    INX
    BIT CXP1FB
    BVS CollisionBL
    BVC CollisionDone

CollisionM1
    INY
CollisionBL
    LDA torpedoVerPos,Y
    CMP #SHIPCOL1
    BCS NoLine1Collision

    LDX #$03
    JMP DoCollision

NoLine1Collision
    CMP #SHIPCOL2
    BCS NoLine2Collision

    LDX #$02
    JMP DoCollision

NoLine2Collision
    CMP #SHIPCOL3
    BCS NoLine3Collision

    LDX #$01
    JMP DoCollision

NoLine3Collision
    CMP #MINECOL1
    BCS NoMine1Collision

    TXA
    ADC #$04
    TAX
    JMP DoMineCollision

NoMine1Collision
    CMP #MINECOL2
    BCS NoMine2Collision

    TXA
    ADC #$02
    TAX
    JMP DoMineCollision

NoMine2Collision
    CMP #MINECOL3
    BCS NoMine3Collision

    JMP DoMineCollision

NoMine3Collision
    CMP #$5E
    BCS NoMineCollision
    BCC CollisionDone

NoMineCollision
    JSR GameOver
    LDX #$00
    LDA sinklevel
    BEQ CollisionDone
    JMP DoCollision

CollisionDone
    STA CXCLR

; TorpedoMovement
    LDX #$03
TorpedoMove          
    LDA torpedoVerPos,X
    BMI TorpedoDone         ; Dead?
    CLC
    ADC torpedoAdd,X
    STA torpedoVerPos,X
TorpedoDone
    DEX
    BPL TorpedoMove

; Prepare Score display
    LDX #11
NextDigit
    TXA
    LSR
    LSR
    TAY
    LDA bcdScore,Y          ; load low/high values of states
    STA tempVar3
    AND #$0F                ; select lower nibble
    TAY                     ; X-> shape of value
    LDA #>zero              ; Load pointer to desired value
    STA spritePointer1,X    ; Store sprite pointer
    STA spritePointer1-2,X  ; Store sprite pointer
    DEX
    LDA digittab,Y          ; Load pointer to desired value
    STA spritePointer1,X    ; Store sprite pointer
    DEX
    DEX 
    LDA tempVar3            ; load low/high values of states
    LSR                     ; select higher nibble... 
    LSR                     ; ...of status value (bcd!)
    LSR                     ; (numbers 0-9)
    LSR                     ;
    TAY                     ; X-> shape of value
    LDA digittab,Y          ; Load pointer to desired value
    STA spritePointer1,X    ; Store sprite pointer
    DEX
    BPL NextDigit

    LDY #<void
    LDX #$00

VoidifyNextDigit
    LDA spritePointer1,X
    BNE VoidifyingDone
    STY spritePointer1,X
    INX
    INX
    CPX #12
    BCC VoidifyNextDigit

VoidifyingDone
    STA HMCLR
    LDA gameState
    ORA torpedoDelay
    BNE MusicDone

;;;;;;;;;; TSM code ;;;;;;;;;;

    INC tempoCount
    LDA tempoCount
    EOR #TEMPODELAY
    BNE MusicDone
    STA tempoCount

    LDY #$01
OtherChannel
    TYA
    CLC
    ADC currentSequence
    TAX
    LDA sequence,X
    CLC
    ADC currentPattern
    TAX
    LDA sequence,X
    CLC
    ADC currentNote
    TAX
    LDA sequence,X
    BEQ Silencium
    STA AUDF0,Y
    LSR
    LSR
    LSR
    LSR
    LSR
    TAX
    LDA soundTypeArray,X
    STA AUDC0,Y
    LDA #10
    CPY #00
    BEQ Silencium
    LDA #8
Silencium
    STA AUDV0,Y
    DEY
    BPL OtherChannel

    INC currentNote
    LDA currentNote
    EOR #PATTERNSIZE
    BNE MusicDone
    STA currentNote
    INC currentPattern
    LDA currentPattern
    EOR #SEQUENCESIZE
    BNE MusicDone
    STA currentPattern
    INC currentSequence
    INC currentSequence
    LDA currentSequence
    EOR #SEQUENCES
    BNE MusicDone
    STA currentSequence
MusicDone
;;;;;;;;;; TSM code ;;;;;;;;;;

VBLANKLOOP
    LDA INTIM
    BNE VBLANKLOOP  ; WAIT FOR VBLANK TIMER
    JMP Maindisplay

Overscan

; Set Overscan timer
    IF COMPILE_VERSION = PAL
        LDA #65
    ELSE
        LDA #36
    ENDIF
    STA TIM64T

    BIT gameState
    BMI NotStartGame
    
    LDA torpedoDelay
    BEQ NoLaunchDec
    DEC torpedoDelay
    JMP NotStartGame

NoLaunchDec
    LDA INPT4
    BMI NotStartGame
    BIT gameState
    BVS NextLive
    JSR StartGame
    JMP NotStartGame

NextLive
    JSR StartGame2
    
NotStartGame
; CheckJoystick
    LDA gameState
    BPL NoLeft
    LDA SWCHA
    ASL
    BCS NoRight
    LDX #%00000000
    STX shipreflect
    LDX xPosabs
    CPX #152
    BEQ NoRight
    INC xPosabs

NoRight
    ASL
    BCS NoLeft
    LDX #%00001000
    STX shipreflect
    LDX xPosabs
    CPX #24
    BEQ NoLeft
    DEC xPosabs
NoLeft

; Move ships
    LDX #SHIP_STRIPES-1
MoveShips
    LDY #$02
MoveShips2
    LDA shiptypeshape,X
    AND #%11110000
    CMP #%00010000
    BNE NoPT
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    AND #%00000011
    EOR #%11111111
    STA sinklevel,X
NoPT    
    LDA shipreflect,X
    BNE MoveLeft

    LDA xPosfloat,X
    CLC
    ADC xPosadd,X
    STA xPosfloat,X
    LDA xPosabs,X
    ADC #$00
    STA xPosabs,X    
    EOR #XEDGE
    BNE PosFine
    STA xPosabs,X    
    JSR InitShip
    JMP SinkingFine

MoveLeft
    LDA xPosfloat,X
    SEC
    SBC xPosadd,X
    STA xPosfloat,X
    LDA xPosabs,X
    SBC #$00
    STA xPosabs,X    
    EOR #$FF
    BNE PosFine
    LDA #XEDGE
    STA xPosabs,X    
    JSR InitShip
    JMP SinkingFine

PosFine    
    DEY
    BPL MoveShips2

    LDY #SUBSINKSPEED
    LDA shiptypeshape,X
    AND #%11110000
    BEQ SinkingSub
    LDY #SINKSPEED
SinkingSub
    JSR SinkSomething
SinkingFine
    DEX
    BNE MoveShips

    LDY #SINKSPEED
    JSR SinkSomething   ; Sink own sub - in case ;-)

    LDX #MINES-1

MoveMines
    LDA expTimer,X
    BNE HandleExplosion
    LDA MINESPEED,X
    LDY level
    CPY #$08
    BCC SlowMines
    ASL

SlowMines    
    CLC
    ADC xPosMinesFloat,X
    STA xPosMinesFloat,X
    BCC NoAbsMineMove
    LDA xPosMines,X     ; Not exploding, normal movement!
    CLC 
    ADC MINEDIR,X
    STA xPosMines,X

NoAbsMineMove
    LDA xPosMines,X
    EOR MINEEOR,X
    BNE NextMine        ; Reset to starting position, if edge is reached

LaunchMine
    LDY #<MINE
    LDA bRestockNow
    BEQ DontRestock
    LDY #<RESTOCK
    LDA $00
    STA bRestockNow

DontRestock    
    STY mineType,X
    LDA MINESTART,X     ;
    STA xPosMines,X     ; Set mine to starting position
    JMP NextMine

HandleExplosion
    BMI LaunchDelay
    DEC expTimer,X      ; Yes, decrement explosion counter
    BNE NextMine
    LDA rnd
    ORA #%11000000
    AND #%11111000    
    STA expTimer,X
    BNE LaunchMine

LaunchDelay
    INC expTimer,X      ; increment explosion counter

NextMine
    DEX
    BPL MoveMines

; Frame Stuff
MinesDone
    JSR Random
    INC frameCounter
    LDA frameCounter
    ROL
    ROL
    ROL
    AND #$03
    TAX
    LDA animTab1,X
    STA wateranim1
    LDA animTab2,X
    STA wateranim2

    LDA gameState
    ORA torpedoDelay
    BEQ NoSFX

; TSFM

        LDX #$01
SecondChannel
        LDY FXType,X
        DEC FXTimer,X
        BPL ContinueEffect
        LDA spawn,Y
        BMI SFXDone
        TAY
        JSR UseChannel1
SFXDone
        INC FXTimer,X
        LDA #$00
        STA AUDV0,X
        BEQ ChannelDone

ContinueEffect
        LDY FXType,X
        LDA FXFreq,X
        CLC
        ADC addf,Y
        STA FXFreq,X
        LSR
        LSR
        LSR
        STA AUDF0,X
        LDA FXVol,X
        CLC
        ADC addv,Y
        AND #$7F
        STA FXVol,X
        LSR
        LSR
        LSR
        STA AUDV0,X
ChannelDone
        DEX
        BPL SecondChannel

NoSFX
    BIT gameState
    BPL GameNotRunning

    LDA SWCHB
    LSR
    BCS NoReset
    JSR AbsoluteGameOver ; RESET: Stop this game
    JMP GameNotRunning

NoReset    
    LDX #1
    ASL SWCHB
    BCS Mode222
    INX

Mode222
    LDA #$FF

CheckTorpedos
    AND torpedoVerPos,X
    DEX
    BPL CheckTorpedos
    ASL
    BCC TorpedosActive
    LDA torpedos
    BEQ StopGame         ; No active torpedos & no reserves...

TorpedosActive
    LDA frameCounter
    ASL
    ASL
    BNE GameNotRunning
    SED
    LDA fuel
    SEC
    SBC #$01
    STA fuel
    CLD
    BNE GameNotRunning
StopGame
    LDY #$05
    JSR DoSFX
    JSR GameOver
GameNotRunning    

    BIT gameState
    BVS GameRunning

    LDA #$AB
    LDX #$CD
    LDY #$EF

    BIT frameCounter
    BPL DoLogo

    LDA bcdHiScore
    LDX bcdHiScore+1
    LDY bcdHiScore+2
    
DoLogo
    STA bcdScore
    STX bcdScore+1
    STY bcdScore+2
GameRunning

; General Ship handler

    LDX #SHIP_STRIPES-1

HandleNextShip

;Handle Explosions
    LDA shiptypeshape,X
    AND #%11110000
    CMP #%01110000
    BNE NoBigExp
    DEC xPosfloat,X
    BNE NoExp
    LDA shiptypeshape,X
    AND #%00001111
    ORA #%10000000
    STA shiptypeshape,X
    LDA #$04
    STA sinklevel,X
    
NoBigExp
    CMP #%01100000
    BNE NoExp
    DEC xPosfloat,X
    BNE NoExp
    JSR InitShip

NoExp

; Prepare kernel positions
    LDA xPosabs,X
    CMP #$08
    BCS NotFirstShift
    LDY #$00
    JMP ShiftingSub
    
NotFirstShift
    CMP #$10
    BCS NotSecondShift
    LDY #$01
    JMP ShiftingSub

NotSecondShift
    CMP #$99
    BCS NotThirdShift
    LDY #$02
    JMP ShiftingSub

NotThirdShift
    CMP #$A1
    BCS NotFourthShift
    LDY #$03
    JMP ShiftingSub

NotFourthShift
    CMP #$A9
    BCS ShiftingDone
    LDY #$04
    JMP ShiftingSub
ShiftingDone

    DEX
    BPL HandleNextShip

OVERSCANLOOP:
    LDA INTIM
    BNE OVERSCANLOOP    ; WAIT FOR OVERSCAN TIMER
    STA WSYNC       ; FINISH WAITING FOR THE CURRENT LINE

    JMP NEWSCREEN


;-----------------------------------------------------------
;ITERATE A RANDOM VALUE
;-----------------------------------------------------------

Random
    LDA rnd
    BNE .skipInit
    LDA #$FF
.skipInit:
    ASL
    ASL
    ASL
    EOR rnd
    ASL
    ROL rnd
    RTS

SinkSomething
    TYA
    AND frameCounter
    BNE SinkingFine2
    LDA sinklevel,X
    BEQ SinkingFine2
    BMI SinkingFine2
    INC sinklevel,X
    LDA sinklevel,X
    CMP #$09
    BNE SinkingFine2

InitShip
    JSR Random
    AND #%01111111
    ORA #$07
    STA xPosadd,X
    LDA level
    ASL
    ASL
    ADC xPosadd,X
    STA xPosadd,X       ; Speed
    
    LDY #$00
    JSR Random
    AND #%00001000
    STA shipreflect,X   ; Direction
    BEQ Forward
    LDY #XEDGE-1

Forward
    STY xPosabs,X

    CPX #$01
    BNE InitType
    LDA frameCounter
    LSR
    BCS InitType
    LDA #%00100000
    BNE SetDestroyer

InitType
    JSR Random
    AND #%01110000
    CMP #%01100000
    BCS InitType

SetDestroyer
    LDY level
    CPY #$06
    BCS AllShipsAllowed
    CMP #%00100000
    BNE NoDestroyer
    LDA #%00110000 ; Spawn cargo ship instead of Destroyer
    BNE AllShipsAllowed

NoDestroyer    
    CPY #$04
    BCS AllShipsAllowed
    CMP #%01000000
    BNE NoRedCross
    LDA #%00110000 ; Spawn Cargo ship instead Red Cross
    BNE AllShipsAllowed

NoRedCross
    CPY #$02
    BCS AllShipsAllowed
    CMP #%01010000
    BNE AllShipsAllowed
    LDA #%00110000 ; Spawn cargo ship instead of Carrier    
    BNE AllShipsAllowed
    
AllShipsAllowed
    STA shiptypeshape,X ; Type

    CMP #%00010000
    BNE NoPT2
    LDA xPosadd,X
    ORA #%00100000
    STA xPosadd,X
NoPT2

    LDY #$00
    CMP #$00       
    BNE NoSub
    INY
NoSub
    STY sinklevel,X
SinkingFine2
    RTS

DoMineCollision
    LDA #$02
    STA tempVar1
    LDA mineType,X
    CMP #<MINEEXP
    BEQ ColDone2
    CMP #<RESTOCK
    BNE .NoRestocking
    JSR Restock
    LDA #$09
    STA tempVar1

.NoRestocking
    LDA #<MINEEXP
    STA mineType,X          ; Already exploding?
    LDA #$FF
    STA torpedoVerPos,Y     ; remove Torpedo
    LDA #EXPTIME/4
    STA expTimer,X
    LDY tempVar1
    JSR DoSFX

ColDone2
    JMP CollisionDone    

DoCollision
    LDA shiptypeshape,X
    AND #%11110000
    CMP #%01100000
    BCS ColDone
    CMP #%01010000
    BNE NoCarrierCol
    LDA #$20    
    JSR AddScore
    LSR xPosadd,X
    LSR xPosadd,X
    LSR xPosadd,X
    LDA xPosadd,X
    BNE CarrierHit
    BEQ BigCollision
NoCarrierCol
    CMP #%00100000
    BCS BigCollision
    LDA #$04
    STA tempVar1
    LDA #$00
    STA sinklevel,X
    LDA shiptypeshape,X
    AND #%00001111
    STA tempVar2
    ORA #%01100000
    STA shiptypeshape,X

    TXA
    BEQ BigCollisionDone

    LDA #$80    
    JSR AddScore

    JMP BigCollisionDone

RedCollision
    LDA #$02
    STA torpedoAdd,Y
    LDA CollTab,X
    STA torpedoVerPos,Y
    LDY #$01
    JSR DoSFX
    JMP CollisionDone    

BigCollision
    CMP #%01000000
    BEQ RedCollision
    LDA #$03
    STA tempVar1
    LDA shiptypeshape,X
    AND #%00001111
    STA tempVar2
    ORA #%01110000
    STA shiptypeshape,X

    LDA #$50    
    JSR AddScore

BigCollisionDone
    LDA #$00
    STA xPosadd,X
CarrierHit
    LDA #$FF
    STA torpedoVerPos,Y
    LDA #EXPTIME
    STA xPosfloat,X
    LDY tempVar1
    JSR DoSFX
    
ColDone
    JMP CollisionDone    

AbsoluteGameOver
    LDA #$01
    STA subs
    LDY #$05    
    JSR DoSFX

GameOver
    LDX #%01000000      ; Assume Life Lost
    STX gameState
    LDX #$3F
    STX torpedoDelay
    LDX #$01
    STX sinklevel
    DEC subs
    BNE NotYet

Immediate
    LDX #$00
    STX gameState
    STX currentSequence
    STX currentPattern
    STX currentNote
    STX frameCounter
    DEX
    STX torpedoDelay
    LDA bcdScore
    STA bcdHiScore
    LDA bcdScore+1
    STA bcdHiScore+1
    LDA bcdScore+2
    STA bcdHiScore+2

SetTorpedos
    LDY #TORPEDOS-1
    LDA #$FF

InitTorpedos
    STA torpedoVerPos,Y
    DEY
    BPL InitTorpedos    ; Kill all torpedos

NotYet
    RTS
    
StartGame
    LDA #$00
    STA bcdScore
    STA bcdScore+1
    STA bcdScore+2      ; Seawolf logo
    STA FXTimer
    STA FXTimer+1
    STA FXType
    STA FXType+1        ; prevent "spawned" SFX garbage
    STA AUDV0
    STA AUDV1
    STA level
    LDA #$03
    STA subs

StartGame2
    LDA #$FF
    STA gameState
    LDA #$00
    STA shiptypeshape
    STA shipreflect
    STA sinklevel
    STA frameCounter
    LDA #$30
    STA xPosabs
    STA torpedoDelay    ; Prevents immediate fire on game start
Restock
    LDA #$99
    STA fuel
    LDA #$50
    STA torpedos
    RTS

        ORG $F900

sequence
    .byte #<Short1 , #<BShort1
    .byte #<Short2 , #<BShort2
    .byte #<Short1 , #<BShort1
    .byte #<Long1  , #<BShort2
    .byte #<Long2  , #<BLong
    .byte #<Quick  , #<BDown
    .byte #<Long2  , #<BUp
    .byte #<Quick  , #<BDown
    .byte #<Long2  , #<BUp
    .byte #<Quick  , #<BShort1
    .byte #<Long2  , #<BLong
    .byte #<Quick  , #<BDown
    .byte #<Long2  , #<BUp
    .byte #<Quick  , #<BDown
    .byte #<Long2  , #<BUp

Short1
    .byte #<D1_00,#<D1_00,#<D1_00,#<D1_01,#<D1_02,#<D1_01,#<D1_00,#<D1_03
Short2
    .byte #<D1_04,#<D1_04,#<D1_04,#<D1_04,#<D1_04,#<D1_04,#<D1_04,#<D1_04
Long1
    .byte #<D1_04,#<D1_04,#<D1_04,#<D1_05,#<D1_03,#<D1_05,#<D1_04,#<D1_06
Long2
    .byte #<D1_07,#<D1_07,#<D1_07,#<D1_07,#<D1_07,#<D1_07,#<D1_07,#<D1_07
Quick
    .byte #<D1_00,#<D1_08,#<D1_09,#<D1_10,#<D1_04,#<D1_11,#<D1_12,#<D1_13

D1_00
    .byte #LEAD_F4
    .byte #LEAD_F4
    .byte #LEAD_F4
    .byte #LEAD_F4
    .byte #LEAD_F4
    .byte #LEAD_F4

D1_01
    .byte #LEAD_E4
    .byte #LEAD_E4
    .byte #LEAD_E4
    .byte #LEAD_E4
    .byte #LEAD_E4
    .byte #LEAD_E4

D1_02
    .byte #LEAD_D4
    .byte #LEAD_D4
    .byte #LEAD_D4
    .byte #LEAD_D4
    .byte #LEAD_D4
    .byte #LEAD_D4

D1_03
    .byte #LEAD_A4
    .byte #LEAD_A4
    .byte #LEAD_A4
    .byte #LEAD_A4
    .byte #LEAD_A4
    .byte #LEAD_A4

D1_04
    .byte #SQUARE_C5
    .byte #SQUARE_C5
    .byte #SQUARE_C5
    .byte #SQUARE_C5
    .byte #SQUARE_C5
    .byte #SQUARE_C5

D1_05
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2

D1_06
    .byte #SQUARE_E5
    .byte #SQUARE_E5
    .byte #SQUARE_E5
    .byte #SQUARE_E5
    .byte #SQUARE_E5
    .byte #SQUARE_E5

D1_07
    .byte #SQUARE_G5
    .byte #SQUARE_G5
    .byte #SQUARE_G5
    .byte #SQUARE_G5
    .byte #SQUARE_G5
    .byte #SQUARE_G5

D1_08
    .byte #LEAD_F4
    .byte #LEAD_F4
    .byte #LEAD_F4
    .byte #LEAD_E4
    .byte #LEAD_E4
    .byte #LEAD_E4

D1_09
    .byte #LEAD_D4
    .byte #LEAD_D4
    .byte #LEAD_D4
    .byte #LEAD_E4
    .byte #LEAD_E4
    .byte #LEAD_E4

D1_10
    .byte #LEAD_F4
    .byte #LEAD_F4
    .byte #LEAD_F4
    .byte #LEAD_A4
    .byte #LEAD_A4
    .byte #LEAD_A4

D1_11
    .byte #SQUARE_C5
    .byte #SQUARE_C5
    .byte #SQUARE_C5
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2

D1_12
    .byte #LEAD_A4
    .byte #LEAD_A4
    .byte #LEAD_A4
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2
    .byte #SQUARE_H4_2

D1_13
    .byte #SQUARE_C5
    .byte #SQUARE_C5
    .byte #SQUARE_C5
    .byte #SQUARE_E5
    .byte #SQUARE_E5
    .byte #SQUARE_E5

BShort1
    .byte #<D2_00,#<D2_00,#<D2_00,#<D2_00,#<D2_00,#<D2_00,#<D2_00,#<D2_00
BShort2
    .byte #<D2_01,#<D2_01,#<D2_01,#<D2_01,#<D2_01,#<D2_01,#<D2_01,#<D2_01
BLong
    .byte #<D2_03,#<D2_03,#<D2_03,#<D2_03,#<D2_03,#<D2_03,#<D2_03,#<D2_03
BDown
    .byte #<D2_04,#<D2_04,#<D2_04,#<D2_04,#<D2_05,#<D2_05,#<D2_05,#<D2_05
BUp
    .byte #<D2_06,#<D2_06,#<D2_06,#<D2_06,#<D2_06,#<D2_06,#<D2_06,#<D2_06

D2_00
    .byte #BASS_D1_1
    .byte #BASS_D1_2
    .byte #BASS_D1_1
    .byte #BASS_D1_1
    .byte #BASS_D1_2
    .byte #BASS_D1_1

D2_01
    .byte #BASS_A1
    .byte #BASS_A1
    .byte #BASS_A1
    .byte #BASS_A1
    .byte #BASS_A1
    .byte #BASS_A1

D2_03
    .byte #BASS_Cw2
    .byte #BASS_H1
    .byte #BASS_Cw2
    .byte #BASS_Cw2
    .byte #BASS_H1
    .byte #BASS_Cw2

D2_04
    .byte #BASS_D1_2
    .byte #BASS_D1_2
    .byte #BASS_D1_2
    .byte #BASS_D2
    .byte #BASS_D2
    .byte #BASS_D2

D2_05
    .byte #BASS_A1
    .byte #BASS_A1
    .byte #BASS_A1
    .byte #BASS_A2
    .byte #BASS_A2
    .byte #BASS_A2

D2_06
    .byte #BASS_E1_2
    .byte #BASS_E1_2
    .byte #BASS_E1_2
    .byte #BASS_E2
    .byte #BASS_E2
    .byte #BASS_E2

    ORG $FA00

ShipStripe
    LDA #STRIPE_SIZE-1
    STA tempVar2
    STX tempVar3
    LDY xPos,X
    LDA xDelay,X
    STA delayPointer
    LDY stripecolor,X
    STY tempVar1
    LDA xPos,X
    STA WSYNC
.wait
    SBC #$0F        ; Battlezone calculate/wait
    BCS .wait       ; 2 in 1 magic !
    AND #$0F        ; Manuels "forget about EOR/ASL
    TAX             ; nonsense" magic :-)
    LDA hmovetab,X  ;
    STA HMP1        ; Fine Position sprite 1
    SBC #$0F        ; carry is clear, so subtract $0F instead of $10
    STA HMP0        ; Fine Position 1 pixel corrected sprite 2
    STA RESP0       ;
    STA RESP1       ;
    STA WSYNC       ;
    STA HMOVE       ; Begin repositioning scannline

    LDA wateranim1
    BEQ DontNow1
    STY COLUBK
DontNow1

    LDA #3                  ; TJ torpedo magic
    DCP torpedoyPos
    ADC #2
    STA ENABL
    LDA #3
    DCP torpedoyPos+1
    ADC #2
    STA ENAM1               ; TJ magic end

    LDX tempVar3
    LDA shipreflect,X
    STA REFP0
    STA REFP1
    ORA shiptypeshape,X
    TAY
    LDA compactshifttable,Y
    CLC
    ADC sinklevel,X
    STA spritePointer1

    LDA wateranim2
    BEQ DontNow2
    LDA tempVar1
    STA COLUBK
DontNow2

    LDA #3                  ; TJ torpedo magic
    DCP torpedoyPos
    ADC #2
    STA ENABL
    LDA #3
    DCP torpedoyPos+1
    ADC #2
    STA ENAM1               ; TJ magic end

    LDA compactshifttable+1,Y
    ADC sinklevel,X
    STA spritePointer2
    LDA compactshifttable+2,Y
    CLC
    ADC sinklevel,X
    STA spritePointer3
    LDA shiptypeshape,X
    LSR
    LSR
    LSR
    LSR
    TAY
    LDA colortable,Y
    ADC sinklevel,X
    STA WSYNC
    STA colorPointer

    LDA tempVar1
    STA COLUBK

    LDA #3                  ; TJ torpedo magic
    DCP torpedoyPos
    ADC #2
    STA ENABL
    LDA #3
    DCP torpedoyPos+1
    ADC #2
    STA ENAM1               ; TJ magic end

    JMP (delayPointer)

JNDELAY
    .BYTE $C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9
    .BYTE $C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9
    .BYTE $C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9
    .BYTE $C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9,$C9
    .BYTE $C9,$C9,$C9,$C9,$C5
    NOP

StripeLine
    LDA #3                  ; TJ torpedo magic
    DCP torpedoyPos
    ADC #2
    STA.w ENABL             ; Waste a cycle
    LDA #3
    DCP torpedoyPos+1
    ADC #2
    STA ENAM1               ; TJ magic end

    LDY tempVar2
    LDA (colorPointer),Y
    STA COLUP0
    STA COLUP1
    LDA (spritePointer1),Y
    STA GRP0
    LDA (spritePointer2),Y
    STA GRP1
    LDA (spritePointer3),Y
    STA GRP0

    SLEEP 5

    DEC tempVar2
    BPL StripeLine
    LDA #$00
    STA GRP0
    STA GRP1
    SEC
    RTS

Statekernel
    LDA #STATEOFFSET+8
    LDX #$01
    JSR PosElement
    DEX
    LDA #STATEOFFSET
    JSR PosElement
    STA WSYNC
    STA HMOVE

; Init State display...

    STX COLUP0  ; x = 0
    STX COLUP1
    STX REFP0
    STX REFP1
    LDA #$06            ; players 3 copies/wide spacing
    STA NUSIZ0          ;
    STA NUSIZ1          ;

; State Loop:

NextStateLine
    STA WSYNC
    LDA HORIZONCOLORS+1,Y
    STA COLUP0
    STA.w COLUP1            ; Waste a cycle

    LDA (spritePointer1),Y         ;
    STA GRP0
    LDA (spritePointer2),Y         ;
    STA GRP1            ;
    LAX (spritePointer6),Y         ; 
    LDA (spritePointer3),Y         ;
    STA GRP0            ;
    LDA (spritePointer4),Y         ;
    STA GRP1            ; 
    LDA (spritePointer5),Y         ; 
    STA GRP0            ; 
    STX GRP1            ; 

    ; SLEEP 9 ; Another 9 cyles here!

    DEY
    BPL NextStateLine   ; Draw next line
    STA WSYNC
    LDA #$00
    STA GRP0
    STA GRP1
    RTS

PosElement
       SEC
       STA WSYNC                ;
.waitzone
       SBC #$0F                 ;
       BCS .waitzone            ; RESP loop
       EOR #$07                 ;
       ASL                      ;
       ASL                      ;
       ASL                      ;
       ASL                      ;
       STA HMP0,X
       STA RESP0,X           ; Position it!
       RTS                      ; done, that's all!

PosElement2
       SEC
       STA WSYNC                ;
.waitzone2
       SBC #$0F                 ;
       BCS .waitzone2           ; RESP loop
       EOR #$07                 ;
       ASL                      ;
       ASL                      ;
       ASL                      ;
       ASL                      ;
       STA HMP0,X
       STA RESP0,X           ; Position it!
       STA WSYNC
       STA HMOVE
       RTS                      ; done, that's all!

DoSFX
        LDX #$01
        LDA FXTimer
        CMP FXTimer+1
        BCS UseChannel1
        LDX #$00
UseChannel1
        LDA audc,Y
        STA AUDC0,X
        LDA startf,Y
        STA FXFreq,X
        LDA startv,Y
        STA FXVol,X
        LDA length,Y
        STA FXTimer,X
        STY FXType,X
        RTS

AddScore SUBROUTINE
    SED
    CLC
    ADC bcdScore+2
    STA bcdScore+2      ; Inc lowest digits
    LDA bcdScore+1
    STA tempVar3        ; remember middle digits
    ADC #$00            ; Inc lowest digits
    STA bcdScore+1
    AND #$F0            ; remember 1000 value
    STA tempVar2
    LDA bcdScore        ; inc highest digits
    ADC #$00
    STA bcdScore
    CLD
    LDA tempVar3        ; compare 1000 digit
    AND #$F0
    CMP tempVar2
    BEQ .NoRestocking
    LDA #$FF            ; if inc'd over 1000 - restock!
    STA bRestockNow
    LDA level
    CMP #19
    BEQ .NoRestocking
    INC level
.NoRestocking    
    RTS

    ORG $FC00

zero
       .byte $3C ; |  XXXX  | $199F
       .byte $7E ; | XXXXXX | $19A0
       .byte $66 ; | XX  XX | $19A1
       .byte $66 ; | XX  XX | $19A2
       .byte $66 ; | XX  XX | $19A3
       .byte $66 ; | XX  XX | $19A4
       .byte $66 ; | XX  XX | $19A5
       .byte $66 ; | XX  XX | $19A6
       .byte $7E ; | XXXXXX | $19A7
       .byte $3C ; |  XXXX  | $19A8

one
       .byte $3C ; |  XXXX  | $19B1
       .byte $3C ; |  XXXX  | $19B2
       .byte $18 ; |   XX   | $19A9
       .byte $18 ; |   XX   | $19AB
       .byte $18 ; |   XX   | $19AC
       .byte $18 ; |   XX   | $19AD
       .byte $18 ; |   XX   | $19AE
       .byte $18 ; |   XX   | $19AF
       .byte $38 ; |  XXX   | $19AA
       .byte $18 ; |   XX   | $19B0

two
       .byte $7E ; | XXXXXX | $19BB
       .byte $7E ; | XXXXXX | $19BC
       .byte $60 ; | XX     | $19B9
       .byte $60 ; | XX     | $19BA
       .byte $7C ; | XXXXX  | $19B8
       .byte $3E ; |  XXXXX | $19B7
       .byte $06 ; |     XX | $19B6
       .byte $66 ; | XX  XX | $19B5
       .byte $7E ; | XXXXXX | $19B4
       .byte $3C ; |  XXXX  | $19B3

three
       .byte $3C ; |  XXXX  | $19BD
       .byte $7E ; | XXXXXX | $19BE
       .byte $66 ; | XX  XX | $19BF
       .byte $06 ; |     XX | $19C0
       .byte $1C ; |   XXX  | $19C1
       .byte $1E ; |   XXXX | $19C2
       .byte $06 ; |     XX | $19C3
       .byte $66 ; | XX  XX | $19C4
       .byte $7E ; | XXXXXX | $19C5
       .byte $3C ; |  XXXX  | $19C6

four
       .byte $06 ; |     XX | $19CD
       .byte $06 ; |     XX | $19CE
       .byte $06 ; |     XX | $19CF
       .byte $06 ; |     XX | $19D0
       .byte $7E ; | XXXXXX | $19CB
       .byte $7E ; | XXXXXX | $19CC
       .byte $66 ; | XX  XX | $19C7
       .byte $66 ; | XX  XX | $19C8
       .byte $66 ; | XX  XX | $19C9
       .byte $66 ; | XX  XX | $19CA

five
       .byte $3C ; |  XXXX  | $19DA
       .byte $7E ; | XXXXXX | $19D9
       .byte $66 ; | XX  XX | $19D8
       .byte $06 ; |     XX | $19D7
       .byte $7E ; | XXXXXX | $19D6
       .byte $7C ; | XXXXX  | $19D5
       .byte $60 ; | XX     | $19D3
       .byte $60 ; | XX     | $19D4
       .byte $7C ; | XXXXX  | $19D1
       .byte $7C ; | XXXXX  | $19D2

six
       .byte $3C ; |  XXXX  | $19E4
       .byte $7E ; | XXXXXX | $19E3
       .byte $66 ; | XX  XX | $19E1
       .byte $66 ; | XX  XX | $19E2
       .byte $7E ; | XXXXXX | $19E0
       .byte $7C ; | XXXXX  | $19DF
       .byte $60 ; | XX     | $19DD
       .byte $60 ; | XX     | $19DE
       .byte $7C ; | XXXXX  | $19DC
       .byte $3C ; |  XXXX  | $19DB

seven
       .byte $30 ; |  XX    | $19EE
       .byte $30 ; |  XX    | $19ED
       .byte $38 ; |  XXX   | $19EC
       .byte $18 ; |   XX   | $19EB
       .byte $1C ; |   XXX  | $19EA
       .byte $0C ; |    XX  | $19E9
       .byte $0E ; |    XXX | $19E8
       .byte $06 ; |     XX | $19E7
       .byte $7E ; | XXXXXX | $19E5
       .byte $7E ; | XXXXXX | $19E6

eight
       .byte $3C ; |  XXXX  | $19EF
       .byte $7E ; | XXXXXX | $19F0
       .byte $66 ; | XX  XX | $19F1
       .byte $66 ; | XX  XX | $19F2
       .byte $7E ; | XXXXXX | $19F4
       .byte $3C ; |  XXXX  | $19F3
       .byte $66 ; | XX  XX | $19F5
       .byte $66 ; | XX  XX | $19F6
       .byte $7E ; | XXXXXX | $19F7
       .byte $3C ; |  XXXX  | $19F8

nine
       .byte $3C ; |  XXXX  | $1A02
       .byte $3E ; |  XXXXX | $1A01
       .byte $06 ; |     XX | $19FF
       .byte $06 ; |     XX | $1A00
       .byte $3E ; |  XXXXX | $19FE
       .byte $7E ; | XXXXXX | $19FD
       .byte $66 ; | XX  XX | $19FB
       .byte $66 ; | XX  XX | $19FC
       .byte $7E ; | XXXXXX | $19FA
       .byte $3C ; |  XXXX  | $19F9

LOGO0
    .byte %11110011
    .byte %10001001
    .byte %00001001
    .byte %00001001
    .byte %00010001
    .byte %00100001
    .byte %01000001
    .byte %10000001
    .byte %10001001
    .byte %01111011

LOGO1
    .byte %11110110
    .byte %00010010
    .byte %00000010
    .byte %00000010
    .byte %00100011
    .byte %11100001
    .byte %00100001
    .byte %00000001
    .byte %00010000
    .byte %11110000

LOGO2
    .byte %00110010
    .byte %00100010
    .byte %00100101
    .byte %00100101
    .byte %11100100
    .byte %01000100
    .byte %01000100
    .byte %01000100
    .byte %10000100
    .byte %10001100

LOGO3
    .byte %00100001
    .byte %00100010
    .byte %01010010
    .byte %01010010
    .byte %10010010
    .byte %10010010
    .byte %00010010
    .byte %00010010
    .byte %00010010
    .byte %00011001

LOGO4
    .byte %11000111
    .byte %00100100
    .byte %00100100
    .byte %00100100
    .byte %00100100
    .byte %00100100
    .byte %00100100
    .byte %00100100
    .byte %00100100
    .byte %11001100

LOGO5
    .byte %10110000
    .byte %10010000
    .byte %00010000
    .byte %00010000
    .byte %00010010
    .byte %00011110
    .byte %00010010
    .byte %00010000
    .byte %00010001
    .byte %00111111

FUEL1
    .byte %10001110
    .byte %10001010
    .byte %11001010
    .byte %10001010
    .byte %11101010

FUEL2
    .byte %11101100
    .byte %10001000
    .byte %11001000
    .byte %10001000
    .byte %11101000

TORP1
    .byte %01001110
    .byte %01001010
    .byte %01001010
    .byte %01001010
    .byte %11101110

TORP2
    .byte %10101000
    .byte %11001000
    .byte %11001100
    .byte %10101010
    .byte %11101100

SUBS1
    .byte %11001110
    .byte %00101010
    .byte %11101010
    .byte %10001010
    .byte %01101010

SUBS2
    .byte %11001100
    .byte %10100010
    .byte %11001110
    .byte %10101000
    .byte %11000110 ; shared

MINE
    .byte %00000000
    .byte %00001000
    .byte %00000100
    .byte %00000100
    .byte %00001000
    .byte %00010000
    .byte %00010000
    .byte %00111000
    .byte %01111100
    .byte %01111100
    .byte %01111100
    .byte %00111000 ; shared

MINEEXP
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00010000
    .byte %00011000
    .byte %00111100
    .byte %01000100
    .byte %10010010
    .byte %00000001
    .byte %01010100
    .byte %01010100 ; shared

RESTOCK
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00111100
    .byte %01100110
    .byte %01111010
    .byte %01111110
    .byte %01011110
    .byte %01100110
    .byte %00111100
    .byte %00000000
    .byte %00000000

void
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000


    ORG $FD00

SUB1
    .byte %00000000
    .byte %01111111
    .byte %11111111
    .byte %11111111
    .byte %00111111
    .byte %00000100
    .byte %00000100
    .byte %00001100
    .byte %00000000

    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
BLANK
    .byte %00000000 ; Dive Dummy sub
    .byte %00000000 ;  
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000
    .byte %00000000 ; Dive Dummy blank
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;

SUB2
    .byte %00000000
    .byte %11111110
    .byte %11111111
    .byte %11111111
    .byte %11111100
    .byte %01100000
    .byte %01100000
    .byte %01100000
    .byte %01100000
    .byte %00000000 ; Dive Dummy
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;

EXP1
    .byte %00000011
    .byte %00001111
    .byte %00010111
    .byte %10100101
    .byte %01001001
    .byte %00001010
    .byte %00010010
    .byte %10100101
    .byte %01001010

EXP2
    .byte %11000000
    .byte %11110000
    .byte %11101000
    .byte %10100101
    .byte %01010010
    .byte %11010000
    .byte %10101000
    .byte %00100101
    .byte %10010010

BATTLE1
    .byte %01111111
    .byte %11111111
    .byte %11111111
    .byte %00011001
    .byte %01111001
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000

BATTLE2
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11111000
    .byte %11011000
    .byte %11011000
    .byte %11011000
    .byte %00000000

BATTLE3
    .byte %11111100
    .byte %11111110
    .byte %11111111
    .byte %01100000
    .byte %01111000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000

PT1
    .byte %01111111
    .byte %01111111
    .byte %00011111
    .byte %00000011
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000

PT2
    .byte %11110000
    .byte %11111000
    .byte %11111100
    .byte %10000000
    .byte %00000000
    .byte %00000000

SINK1
    .byte %00000000 ; Shared
    .byte %00000000
    .byte %00000000 ; Shared

    .byte %00011111
    .byte %00111111
    .byte %01111110
    .byte %01110100
    .byte %01100000
    .byte %01000000
    .byte %00000000 ; Dive Dummy
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;

SINK2
    .byte %00000000 ; Shared
    .byte %00000000
    .byte %00000000 ; Shared

    .byte %11000001
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000 ; Dive Dummy
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;

SINK3
    .byte %00000000 ; Shared
    .byte %00000000
    .byte %00000000 ; Shared

    .byte %11100000
    .byte %11110000
    .byte %01111000
    .byte %00111100
    .byte %00001100
    .byte %00000000
    .byte %00000000 ; Dive Dummy
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;
    .byte %00000000 ;

RED1
    .byte %11111111
    .byte %11111101
    .byte %11111000
    .byte %01101101
    .byte %01101111
    .byte %01100000
    .byte %00000000
    .byte %00000000
    .byte %00000000

RED2
    .byte %11111100
    .byte %11111110
    .byte %11111111
    .byte %10110000
    .byte %10110000
    .byte %00110000
    .byte %00000000
    .byte %00000000
    .byte %00000000

CARRIER1
    .byte %00111111
    .byte %01111111
    .byte %01111111
    .byte %11111111
    .byte %01101010
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000

CARRIER2
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11110110
    .byte %01110111
    .byte %01110000
    .byte %01110000
    .byte %00100000

CARRIER3
    .byte %11110000
    .byte %11110000
    .byte %11111000
    .byte %11111111
    .byte %00000000
    .byte %10000000
    .byte %00000000
    .byte %00000000
    .byte %00000000

CARGO1
    .byte %00011111
    .byte %00111111
    .byte %01111111
    .byte %11111111
    .byte %00001111
    .byte %00000001
    .byte %00000000
    .byte %00000000
    .byte %00000000

CARGO2
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11111111
    .byte %11000100
    .byte %11000100
    .byte %00000100
    .byte %00000000
    .byte %00000000

CARGO3
    .byte %11111000
    .byte %11111100
    .byte %11111110
    .byte %11111111
    .byte %01110000
    .byte %00000000
    .byte %00000000
    .byte %00000000
    .byte %00000000

BIGEXP1
    .byte %01111111
    .byte %01111111
    .byte %11111001
    .byte %11110000
    .byte %11100000
    .byte %00001000
    .byte %00101000
    .byte %01000010
    .byte %10010010

BIGEXP2
    .byte %11111111
    .byte %11111011
    .byte %11000000
    .byte %00000000
    .byte %00000100
    .byte %10001010
    .byte %11010001
    .byte %01000001
    .byte %00100000

BIGEXP3
    .byte %11110000
    .byte %11111000
    .byte %11111100
    .byte %00111100
    .byte %00000110
    .byte %10000000
    .byte %01001100
    .byte %00100100
    .byte %10100010

    ORG $FE00

compactshifttable
    .byte #<BLANK,#<BLANK,#<SUB1,#<SUB2,#<BLANK,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<SUB2,#<SUB1,#<BLANK,#<BLANK,#<BLANK,#<BLANK

    .byte #<BLANK,#<BLANK,#<PT1,#<PT2,#<BLANK,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<PT2,#<PT1,#<BLANK,#<BLANK,#<BLANK,#<BLANK

    .byte #<BLANK,#<BLANK,#<BATTLE1,#<BATTLE2,#<BATTLE3,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<BATTLE3,#<BATTLE2,#<BATTLE1,#<BLANK,#<BLANK,#<BLANK

    .byte #<BLANK,#<BLANK,#<CARGO1,#<CARGO2,#<CARGO3,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<CARGO3,#<CARGO2,#<CARGO1,#<BLANK,#<BLANK,#<BLANK

    .byte #<BLANK,#<BLANK,#<RED1,#<RED2,#<BLANK,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<RED2,#<RED1,#<BLANK,#<BLANK,#<BLANK,#<BLANK

    .byte #<BLANK,#<BLANK,#<CARRIER1,#<CARRIER2,#<CARRIER3,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<CARRIER3,#<CARRIER2,#<CARRIER1,#<BLANK,#<BLANK,#<BLANK

    .byte #<BLANK,#<BLANK,#<EXP1,#<EXP2,#<BLANK,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<EXP2,#<EXP1,#<BLANK,#<BLANK,#<BLANK,#<BLANK

    .byte #<BLANK,#<BLANK,#<BIGEXP1,#<BIGEXP2,#<BIGEXP3,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<BIGEXP3,#<BIGEXP2,#<BIGEXP1,#<BLANK,#<BLANK,#<BLANK

    .byte #<BLANK,#<BLANK,#<SINK1,#<SINK2,#<SINK3,#<BLANK,#<BLANK,#<BLANK
    .byte #<BLANK,#<BLANK,#<SINK3,#<SINK2,#<SINK1,#<BLANK,#<BLANK,#<BLANK

animTab1
    .byte $00,$00,$FF,$00
animTab2
    .byte $00,$FF,$FF

CollTab
    .byte $FF ; Part of animTab2
    .byte SHIPCOL3, SHIPCOL2, SHIPCOL1

MINEDIR
    .byte $01,$01,$FF,$FF,$01,$01

MINESPEED
    .byte $20,$40,$20,$40,$20,$40

MINEEOR
    .byte XEDGEMINES,XEDGEMINES

MINESTART
    .byte 0,0
    .byte XEDGEMINES,XEDGEMINES
    .byte 0,0

; TSFX Values
; Shot,Bink,Mineexp,Shipsink,Shipexp,Subsink,restock,charge

;000 0 Square  = 4
;001 1 Bass    = 6
;010 2 Pitfall = 7
;011 3 Noise   = 8
;100 4 Buzz    = 15
;101 5 Lead    = 12
;110 6 Saw     = 1
;111 7 Engine  = 3

addf
    .byte   0      , 0      , 1      , -128   , 2      , -32    , 1      , -128   , 2      , -4     , 0      
addv 
    .byte   1      , 0      , 0      , -2     , 0      , -4     , 0      , -2     , 0      , 0      , 1      
audc 
    .byte   8      , 4      , 8      , 8      , 8      , 12     , 8      , 8      , 8      , 4      , 12      
startf
    .byte   20*8-1 , 6*8-1  , 8*8-1  , 0*8-1  , 20*8-1 , 32*8-1 , 8*8-1  , 0*8-1  , 20*8-1 , 16*8-1 , 20*8-1 
startv
    .byte   2*8-1  , 15*8-1 , 15*8-1 , 15*8-1 , 15*8-1 , 15*8-1 , 5*8-1  , 9*8-1  , 5*8-1  , 15*8-1 , 2*8-1  
length 
    .byte   3*8-1  , 1*8-1  , 2*8-1  , 5*8-1  , 3*8-1  , 7*8-1  , 2*8-1  , 4*8-1  , 2*8-1  , 2*8-1  , 3*8-1  
spawn 
    .byte   $FF    , $FF    , 6      , 7      , 8      , $FF    , $FF    , $FF    , $FF    , $FF    , $FF    

    ORG $FF00

colortable
    .byte #<CSUB1,#<CPT1,#<CBATTLE1,#<CCARGO1,#<CRED1,#<CCARRIER1,#<CBLACK1,#<CBLACK1,#<CBLACK1

CCARGO1
    .byte #$06
    .byte #$04
    .byte #$02
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00

CCARRIER1
    IF COMPILE_VERSION = PAL
        .byte #$56
        .byte #$54
        .byte #$52
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
    ELSE
        .byte #$D6
        .byte #$D4
        .byte #$D2
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
    ENDIF


CBATTLE1
    IF COMPILE_VERSION = PAL
        .byte #$44
        .byte #$42
        .byte #$40
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
    ELSE
        .byte #$F4
        .byte #$F2
        .byte #$F0
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
    ENDIF

CSUB1
    IF COMPILE_VERSION = PAL
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$60
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
    ELSE
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$40
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
    ENDIF

CRED1
    IF COMPILE_VERSION = PAL
        .byte #$0A
        .byte #$60
        .byte #$0A
        .byte #$0A
        .byte #$0A
        .byte #$00
        .byte #$0A
        .byte #$0A
        .byte #$0A
    ELSE
        .byte #$0A
        .byte #$60
        .byte #$0A
        .byte #$0A
        .byte #$0A
        .byte #$00
        .byte #$0A
        .byte #$0A
        .byte #$0A
    ENDIF

CPT1
    IF COMPILE_VERSION = PAL
        .byte #$00
        .byte #$00
        .byte #$A4
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
    ELSE
        .byte #$00
        .byte #$00
        .byte #$64
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
        .byte #$00
    ENDIF

CBLACK1
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00
    .byte #$00

ShiftingSub
    SEC
    SBC shiftsbctable,Y
    STA xPos,X    
    LDA shiptypeshape,X
    AND #%11111000
    ORA shiftoratable,Y
    STA shiptypeshape,X
    JMP ShiftingDone

shiftsbctable
    .byte #$00, #$08, #$10, #$18, #$20

shiftoratable
    .byte 4,3,2,1,0

    IF COMPILE_VERSION = PAL

stripecolor2
    .byte $D4,$D6,$D8
stripecolor    
    .byte $D2,$DA,$DC,$DE

    ELSE

stripecolor2
    .byte $84,$86,$88
stripecolor    
    .byte $82,$8A,$8C,$8E

    ENDIF

hmovetab
    .byte $80,$70,$60,$50,$40,$30,$20,$10,$00
    .byte $F0,$E0,$D0,$C0,$B0,$A0,$90


    IF COMPILE_VERSION = PAL

HORIZONCOLORS
    .byte $DE,$4A,$48,$66,$66,$86,$66,$66,$86,$66,$86,$86,$86,$A6,$86

HORIZONCOLORS2
    .byte $A6,$C6,$C6,$C6,$C6,$C6,$C6,$D6,$C6,$D6

    ELSE

HORIZONCOLORS
    .byte $8E,$3A,$38,$46,$46,$56,$46,$46,$56,$46,$56,$56,$56,$66,$56

HORIZONCOLORS2
    .byte $66,$76,$76,$76,$76,$76,$76,$86,$76,$86

    ENDIF

HORIZONSHAPE
       .byte %11111111
       .byte %11111111
       .byte %01111111
       .byte %00111111
       .byte %00011111
       .byte %00000111  ; Shared

digittab
    .byte #<zero,#<one,#<two,#<three,#<four
    .byte #<five,#<six,#<seven,#<eight,#<nine
    .byte #<LOGO0,#<LOGO1,#<LOGO2,#<LOGO3,#<LOGO4,#<LOGO5

soundTypeArray
    .byte 4,6,7,8,15,12,1,3

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start